_ = require 'underscore'
coffee = require './portable-coffee-script/index'
# {events} = modules

#log = console.log unless log?

print_call_stack = ->
  stack = new Error().stack
  console.log "PRINTING CALL STACK"
  console.log stack

# ---dependent functions (of CCNode)---
# ... addChild (essential)
# ... setVisible (for implement show prop)

# watch 함수에서 중요한 것은,
# 항상 scope자기 자신이 자신의 변수를 감시하는 것이 아니다는 것이다.
# watch item마다 감시하는 scope와 감시당하는 scope가 분리되여있다.
# 그래야 repeated 기능을 만들 수 있다.

# reserved at template
reservedProps = [
	'type',
	'bind',
	'template'
	'children'
	'repeat'
	'show'
	'push_action'
	'pop_action'
#	'id'
	'priority'
]


to_arr = (arg) ->
	if _.isString arg
		arg.split(' ').map (c) -> parseFloat c
	else
		arg

slice_first_char = (string) ->
	unless typeof string == 'string'
		nothing = string
		nothing
	else
		string.substr(1, string.length-1)

randomId = ->
	Math.floor(Math.random() * 9007199254740992)


# return a function that return evaluated
makeFunc = (str) ->
	contents = [
		'return ->'
		"  return (#{str})"
	].join('\n')
	func_str = coffee.compile contents
	fn = null
	eval('fn = ' + func_str)

	(scope) ->
#		log 'scope : ', scope.$$controllerName
#		if scope.$$controllerName == 'AppCtrl'
#			do print_call_stack
#		log String(fn)
		cur = fn.call(scope)
#		log cur
		cur


# return a function that return interpolated str
interpolate = (str) ->
	return (-> str) if (typeof str) != 'string'
	resArr = []
	recent = 0
	str.replace /{{([^}]+)}}/g, (match, p1, offset, string) ->
		if recent < offset 
			resArr.push str.substr recent, offset - recent
		recent = offset + match.length
		resArr.push makeFunc(p1)
		''

	if recent < str.length
		resArr.push str.substr recent, str.length - recent

	(scope) ->
		something = null
		for mola in resArr
			if typeof mola == 'string'
				ala = mola
			else if typeof mola == 'function'
	#			log 'in the interpolation'.bold
				ala = mola scope
			else
				throw 'unrecognized type of mola : ' + typeof mola

			unless something?
				something = ala
			else
				something += ala

		something

test = ($scope, watches) ->
	changed = false
	for w in watches
		# 리스너가 $scope.$$remove_w_if로 아이템을 제거하는 경우
		# 바로 반영이 안되여 undefined된 w를 처리할 수도 있음 
		continue unless w?

		cur = w.targetFunc(w.watched_scope)
		if (_.isArray cur) and (_.isArray w.prev)
			res = cur.length == w.prev.length
		else
			cur_str = JSON.stringify(cur)
			res = w.prev_str == cur_str

#		console.log 'cur : ' + cur_str + ', prev: ' + w.prev_str
#		console.log 'res : ' + res

		if not res
			prev = w.prev
			w.prev = _.clone cur
			w.prev_str = cur_str
			changed = true
			# listener가 또 다시 apply를 할 수도 있어서 무한루프에 빠지기도 하고
			# 지금 scope.$$watches를 순회하는데, scope.$$watches에서
			# 아이템이 추가, 삭제되는 경우도 있음.
			w.listener.call($scope, cur, prev)

	changed	

# 복잡한 버그 생길 수도 있음
# 테스트 할 때,  추가,삭제를 다루는 걸 먼저 해야지
# undefined로 변경된 아이템을 처리하는 listener가 안불림
innerApply_r = ($scope) ->
	changed = false
	changed = true if test($scope, $scope.$$firstWatches)
	chagned = true if test($scope, $scope.$$watches)
	_.reduce $scope.$$childScopes, ((memo, s) -> innerApply_r(s) or memo), changed
	
genScope = (parentScope) ->
	Scope = ->
	Scope.prototype = parentScope

	$scope = new Scope()
	$scope.$$childScopes = []
	$scope.$$firstWatches = []
	$scope.$$watches = []

	is_root_scope = true if parentScope == null

	if is_root_scope
		$scope.$$rootScope = $scope
#		$scope.$$elements = {}
	else
		parentScope.$$childScopes.push $scope
		$scope.$$rootScope = parentScope.$$rootScope

	$scope.$$watchFirst = (targetFunc, watched_scope, listener) ->
		$scope.$$firstWatches.push
			targetFunc: targetFunc
			listener: listener
			prev: null
			prev_str: ''
			watched_scope: watched_scope		

	$scope.$$watch = (targetFunc, watched_scope, listener) ->
		$scope.$$watches.push
			targetFunc: targetFunc
			listener: listener
			prev: null
			prev_str: ''
			watched_scope: watched_scope
	 	
	$scope.$apply = (fn) ->
		fn?()
		loop
			break unless innerApply_r $scope
		null

	$scope.$$remove_w_if = (pred) ->
		for w, index in $scope.$$firstWatches
			if pred(w)
				delete $scope.$$firstWatches[index]
		$scope.$$firstWatches = _.compact $scope.$$firstWatches

		for w, index in $scope.$$watches
			if pred(w)
				delete $scope.$$watches[index]
		$scope.$$watches = _.compact $scope.$$watches

	$scope.$$removeFromParent = ->
		parentScope.$$childScopes = _.reject parentScope.$$childScopes, (cs) -> cs == $scope

	$scope

getManagedProps = (template) ->
	results = []
	for name of template
		prop = template[name]
		if not _.contains reservedProps, name
			results.push name
	results

module.exports = (dicts...) ->
	# make a appropriate drwable object dictionary...
	# compose dictionaries to one dictionary
	if dicts == null or dicts.length == 0
		dict = []
	else
		dict = dicts[0]
		dict = _.extend dict, dicts[i] for i in [1...dicts.length]
	

	pub = {}

	pub.include = (newDict) ->
		dict = _.extend dict, newDict

	# traverse node
	# if node has controller... create scope
	createScope_r = (template, parentScope, controllers) ->
		is_root_scope = true unless parentScope
		node_has_scope = true if template.controller

		throw 'root node must have a controller' if is_root_scope and not node_has_scope

		if node_has_scope
			scope = genScope parentScope
			ctrl = controllers[template.controller]
			ctrl scope
			scope.$$controllerName = template.controller
		else
			scope = parentScope

		if template.children?
			for child in template.children
				createScope_r child, scope, controllers

		scope

	registerProps = (def, template, managedProps, node, watching_scope, watched_scope) ->
		while def?
			managedProps.forEach (name, idx) ->
				prop = def[name]
				if typeof prop == 'function'
					# register
					watching_scope.$$watch interpolate(template[name]), watched_scope, (value) ->
						prop.call node, value

					delete managedProps[idx]

			managedProps = _.compact managedProps
			def = dict[def.inherit]

	createNode_r = (template, scope, repeated) ->
		node_has_scope = true if template.controller?

		if repeated?
			watching_scope = repeated.parentScope
		else
			watching_scope = scope

		def = dict[template.type]
		throw "unsupported type : #{template.type}" unless def?

		# create a node
		unless def.cons_args? 
			node = do def.cons
		else
			initArgs = def.cons_args.map (arg) -> interpolate(template[arg])(scope)
			node = def.cons initArgs...

		if template.show?
			fn = interpolate template.show
			watching_scope.$$watch fn, scope, (res) ->
				if res == true or res == 'true'
					node.setVisible true
				else
					node.setVisible false

		if template.repeat?
			node.$$repeatedChildren = []
			text = template.repeat.bind.replace ',', ' '
			words = text.split(' ')
			words = _.compact words
			if words.length == 4
				itr = slice_first_char words[0]
				indexer = slice_first_char words[1]
				container = words[3]
			else if words.length == 3
				itr = slice_first_char words[0]
				indexer = null
				container = words[2]
			else
				throw "repeat usage wrong... (#{words}:not 3~4 words)"

			childTemplate = template.repeat.template
			push_action = slice_first_char(template.repeat.push_action)
			pop_action = slice_first_char(template.repeat.pop_action)

			# don't need to call interpolate function because it already interpolated...
			fn = makeFunc container

			watching_scope.$$watch fn, scope, (list, prev_list) ->
				throw "invalid repeated list : #{list}" if not list?

				prev_list = [] if prev_list is null

				if list.length > prev_list.length
					# add exceeded elements
					for i in [prev_list.length...list.length]
						do (i) ->
							childScope = genScope scope
							childScope[itr] = list[i]
							childScope[indexer] = i if indexer?
							childNode = createNode_r childTemplate, childScope,
								parentScope: scope
							childNode.$$scope = childScope
							node.addChild childNode, (childTemplate.priority or 0)
							
							if push_action?
								action_func = scope[push_action]
								throw 'push action is not function' if typeof action_func != 'function'
								action_func.call childNode, i, (i-prev_list.length), (list.length-prev_list.length)
							# need assertion of perfect sync
							node.$$repeatedChildren.push childNode
							child_fn = makeFunc "#{container}[#{i}]"
							scope.$$watch child_fn, scope, (cur, prev) ->
								scope.$apply ->
									childScope[itr] = cur

				else if list.length < prev_list.length
					# delete fallen elements
					for i in [list.length...prev_list.length]
						childNode = node.$$repeatedChildren[i]
						after_work = -> childNode.removeFromParent()
						if pop_action?
							action_func = scope[pop_action]
							throw 'pop function is not function' if typeof action_func != 'function'
							action_func.call childNode, i, (i-list.length), (prev_list.length-list.length), ->
								do after_work
						else
							do after_work
						childScope = childNode.$$scope
						scope.$$remove_w_if (w) -> w.watched_scope == childScope
						childScope.$$removeFromParent()
					node.$$repeatedChildren = node.$$repeatedChildren.splice 0, list.length


		if template.children?
			template.children.forEach (child, index) ->
				if child.controller?
					childScope = _.find scope.$$childScopes, (s) ->
						s.$$controllerName == child.controller
					throw "can\'t find @{child.controller} controller" if childScope == null	
				else
					childScope = scope
				childNode = createNode_r child, childScope
				node.addChild childNode, (child.priority or 0)

		managedProps = getManagedProps template
		registerProps def, template, managedProps, node, watching_scope, scope

		node

	pub.make_view = (template, controllers) ->
		rootScope = createScope_r template, null, controllers
		rootNode = createNode_r template, rootScope
		# apply 한 번하면 repeated만 constructor에 없는 초기속성이
		# 반영되지가 않음
		# 임시방편으로 2번 호출해줌
		rootScope.$apply -> # for initiation
		rootScope.$apply -> # for initiation
		rootNode

	pub