make_dd = require '../src/view.coffee'
require 'colors'
_ = require 'underscore'

util = require 'util'
clear = ->
	util.print "\u001b[2J\u001b[0;0H"

class S
	constructor: (text, color) ->
		@text = text
		@color = color
		@children = []
		@star = 0

	addChild: (child) ->
		@children.push child
		child.parent = @

	draw: (tab) ->
		tab = '' unless tab?
		star = ''
		star += '☆' for i in [0...@star]
		console.log tab + @text[@color] + star
		@children.forEach (child) ->
			child.draw(tab + '  ')

	setText: (t) ->
		@text = t

	setColor: (c) ->
		@color = c

	setStar: (n) ->
		@star = n

	removeFromParent: () ->
		@parent.children = _.without @parent.children, @
		@parent = null

str_dict =
	string:
		cons_args: ['text', 'color']
		cons: (text, color) ->
			new S(text, color)
		text: (t) ->
			@setText t
		color: (c) ->
			@setColor c
		star: (n) ->
			console.log '들어온 n:' + n
			@setStar n

dd = make_dd(str_dict)

template =
	type: 'string'
	text: 'hi'
	color: 'yellow'
	controller: 'AppCtrl'
	children: [
		{
			type: 'string'
			text: 'my info'
			color: 'white'
			star: 3
			controller: 'MyInfoCtrl'
			children: [
				{
					type: 'string'
					text: 'name : seo byeong gee'
					color: 'white'
				}
				{
					type: 'string'
					text: 'age : 21'
					color: 'white'
				}
				{
					type: 'string'
					text: 'company : redduck'
					color: 'white'
				}
			]
		}
	]
	repeat:
		bind: '@item, @i in @list'
		template:
			type: 'string'
			text: '{{@i + " : " + @item}}'
			star: '{{@i + 1}}'
			color: 'white'

root = null

controllers =
	AppCtrl: ($scope) ->
		$scope.list = ['item1', 'item2', 'item3', 'item4', 'item5']
		setTimeout ->
			$scope.$apply ->
				do $scope.list.shift
			do root.draw
		, 1000

		setTimeout ->
			$scope.$apply ->
				do $scope.list.shift
			do root.draw
		, 2000

		setTimeout ->
			$scope.$apply ->
				$scope.list[0] = 'changed'
			do root.draw
		, 3000

	MyInfoCtrl: ($scope) ->

root = dd.make_view template, controllers

do root.draw
